summaryrefslogtreecommitdiff
path: root/plugins/rust
diff options
context:
space:
mode:
authorCarlo Sala <carlosalag@protonmail.com>2021-10-06 22:43:09 +0200
committerMarc Cornellà <hello@mcornella.com>2021-12-28 12:05:04 +0100
commit89a740be2d5487c96f01e4eaae7e280caf555019 (patch)
treecb100d28c8926851e438e0dfb4cb4140fe4a9f49 /plugins/rust
parent5fbd4c83f6e70a66c555fc7ace7dda2c056b8663 (diff)
downloadzsh-89a740be2d5487c96f01e4eaae7e280caf555019.tar.gz
zsh-89a740be2d5487c96f01e4eaae7e280caf555019.tar.bz2
zsh-89a740be2d5487c96f01e4eaae7e280caf555019.zip
refactor(rust)!: merge `cargo` and `rustup` plugins into `rust` plugin (#10270)
BREAKING CHANGE: `cargo` and `rustup` plugins have been moved to the `rust` plugin since they're part of the Rust toolchain. If you're using these, update your .zshrc file to use `rust` instead. Closes #10270 Co-authored-by: Marc Cornellà <hello@mcornella.com>
Diffstat (limited to 'plugins/rust')
-rw-r--r--plugins/rust/README.md2
-rw-r--r--plugins/rust/_rustc (renamed from plugins/rust/_rust)0
-rw-r--r--plugins/rust/rust.plugin.zsh28
3 files changed, 29 insertions, 1 deletions
diff --git a/plugins/rust/README.md b/plugins/rust/README.md
index 83d7d91ba..e05364474 100644
--- a/plugins/rust/README.md
+++ b/plugins/rust/README.md
@@ -1,6 +1,6 @@
# rust
-This plugin adds completion for [`rustc`](https://doc.rust-lang.org/rustc/index.html), the compiler for the Rust programming language.
+This plugin adds completion for [`rustc`](https://doc.rust-lang.org/rustc/index.html), the compiler for the Rust programming language, as well as for `rustup` and `cargo` if you have the Rust toolchain installed.
To use it, add `rust` to the plugins array in your zshrc file:
diff --git a/plugins/rust/_rust b/plugins/rust/_rustc
index 6e3f344cd..6e3f344cd 100644
--- a/plugins/rust/_rust
+++ b/plugins/rust/_rustc
diff --git a/plugins/rust/rust.plugin.zsh b/plugins/rust/rust.plugin.zsh
new file mode 100644
index 000000000..ced6eb4aa
--- /dev/null
+++ b/plugins/rust/rust.plugin.zsh
@@ -0,0 +1,28 @@
+if ! (( $+commands[rustup] && $+commands[cargo] )); then
+ return
+fi
+
+# Add completions folder in $ZSH_CACHE_DIR
+# TODO: 2021-12-28: remove this bit of code as it exists in oh-my-zsh.sh
+command mkdir -p "$ZSH_CACHE_DIR/completions"
+(( ${fpath[(Ie)"$ZSH_CACHE_DIR/completions"]} )) || fpath=("$ZSH_CACHE_DIR/completions" $fpath)
+
+# If the completion file doesn't exist yet, we need to autoload it and
+# bind it to `cargo`. Otherwise, compinit will have already done that
+if [[ ! -f "$ZSH_CACHE_DIR/completions/_cargo" ]]; then
+ autoload -Uz _cargo
+ declare -A _comps
+ _comps[cargo]=_cargo
+fi
+
+# If the completion file doesn't exist yet, we need to autoload it and
+# bind it to `rustup`. Otherwise, compinit will have already done that
+if [[ ! -f "$ZSH_CACHE_DIR/completions/_rustup" ]]; then
+ autoload -Uz _rustup
+ declare -A _comps
+ _comps[rustup]=_rustup
+fi
+
+# Generate completion files in the background
+rustup completions zsh >| "$ZSH_CACHE_DIR/completions/_rustup" &|
+rustup completions zsh cargo >| "$ZSH_CACHE_DIR/completions/_cargo" &|